Ruby - Bug #12359

Named captures "conflict” warning is unnecessary and limits uses of named captures
05/09/2016 02:46 PM - headius (Charles Nutter)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.3.0p0 (2015-12-25 revision Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:
53290) [x86_64-darwin14] UNKNOWN

Description

There's currently a warning whenever a named capture in a regular expression has the same name as an already-declared local
variable:

$ ruby23 -v -e 'x = 1; /(?2<x>foo0)/ =~ "foo"'
ruby 2.3.0p0 (2015-12-25 revision 53290) [x86_64-darwinl4]
—e:1l: warning: named capture conflicts a local variable - x

It also warns if you have two expressions using the same named capture:

$ ruby23 -v -e '/ (?<x>foo)/ =~ "foo"; /(?<x>foo)/ =~ "foo"'
ruby 2.3.0p0 (2015-12-25 revision 53290) [x86_64-darwinl4]
—e:1l: warning: named capture conflicts a local variable - x

| do not believe either of these warnings are useful, since the only option for fixing them is to use a new variable name for every
named capture.

| have a few more reasons, as well:

e Using the same named capture on both the "then" and "else" branches of an "if" statement will produce a warning. Changing
one of the names requires additional work to join the to branches back together (since now there's no single variable resulting
from them).

¢ |tis not possible to initialize a variable with the same name as a named capture.

¢ The pattern that results from this warning is renaming a capture something like "name2" and then having "name = name2" after
the match. Ugly.

Risks of removing the warning:

¢ When a named capture writes to an already-declared variable, that may surprise a user.

I think this risk is very low, especially since you'd have to turn on verbose mode to even see the warning.

Related issues:
Related to Ruby - Bug #9623: warning: "named capture conflicts a local variab... Closed

Associated revisions

Revision 75a68057¢c712897bce6d787114ffa72504556756 - 06/13/2016 11:50 AM - nobu (Nobuyoshi Nakada)
parse.y: no named capture conflict warnings
® parse.y (reg_named_capture_assign_iter): remove named capture
conflict warnings. it is just annoying rather than useful.
[ruby-core:75416] [Bug #12359]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55396 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 75268057 - 06/13/2016 11:50 AM - nobu (Nobuyoshi Nakada)
parse.y: no named capture conflict warnings
® parse.y (reg_named_capture_assign_iter): remove named capture

conflict warnings. it is just annoying rather than useful.
[ruby-core:75416] [Bug #12359]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55396 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/09/2016 02:51 PM - headius (Charles Nutter)

See https://github.com/jruby/jruby/issues/3865 for a related issue in JRuby.

#2 - 05/10/2016 05:08 PM - headius (Charles Nutter)

Related Ruby issue: https://bugs.ruby-lang.org/issues/9623

| think the warning needs to be softened to allow repeat use in literal regexp at the very least.

#3 - 05/10/2016 06:44 PM - headius (Charles Nutter)

I have worked around this for now in JRuby by modifying the warning to only fire if a named capture was previously declared as something other than
a named capture.

The commit to JRuby is here: https:/github.com/jruby/jruby/commit/3ebc198860905084231d2a1356ea46718b8612b0

It resolves the verbose noise issue we had with our date/format implementation.

| propose that the warning should only fire when it is a mixed-use variable, i.e. it is potentially assigned both as a named capture and as a normal
local variable.

I'd actually like to get rid of it altogether, but it's really just this mixed-use case that needs a warning.

#4 - 05/11/2016 08:19 AM - Eregon (Benoit Daloze)

- Related to Bug #9623: warning: "named capture conflicts a local variable" does not allow loops with named captures added

#5 - 06/07/2016 05:54 AM - nobu (Nobuyoshi Nakada)
Agree.

https://github.com/ruby/ruby/compare/trunk...nobu:bug/12359-no-capture-warnings

#6 - 06/13/2016 09:27 AM - matz (Yukihiro Matsumoto)
Accepted.

Matz.

#7 - 06/13/2016 11:50 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset r55396.

parse.y: no named capture conflict warnings

® parse.y (reg_named_capture_assign_iter): remove named capture
conflict warnings. it is just annoying rather than useful.
[ruby-core:75416] [Bug #12359]
